/*
 * @(#)environment.h	1.2  3/18/87
 */
#ifndef environment_h
#define environment_h
#ifndef map_h
#include "map.h"
#endif

typedef enum {E_ScheduledImport, E_Imported, 
	      E_ScheduledExport, E_Exported } EnvironmentStage;

extern char *makeOIDFileName();

extern void setStage(/* id, stage */);
/* OID id; EnvironmentStage stage; */

extern void resolveGlobal(/* p, v */);
/* NodePtr p; Value *v; */

extern void defineGlobal(/* p, id */);
/* NodePtr p; OID id; */

extern NodePtr OTLookup(/* id */);
/* OID id; */

extern void OTInsert(/* p, id */);
/* NodePtr p; OID id; */

extern void scheduleOutput(/* id */);
/* OID id; */

extern void scheduleInput(/* id */);
/* OID id; */

extern NodePtr loadObject(/* id */);
/* OID id; */

extern void doInput(), doOutput();
extern void doExports(/* p */);
/* NodePtr p; */
extern void doImports(/* p */);
/* NodePtr p; */

extern Map translateOIDMap;
extern Map objectTable;
extern Map environmentMap;

#endif
