#ifndef tags_h
#define tags_h
typedef enum {
/* */
/* %W%  %G% */
/* */
/* This file defines the tags for the nodes manipulated by the compiler. */
/* COMMENT LINES BEGIN WITH % IN THE FIRST COLUMN */
/* THERE MAY BE NO BLANK LINES IN THIS FILE */
/* */
/* The decision on how many local variables a node has is based on the value */
/* of its tag.  Look at F_NewNode in nodes.c to see this.  LASTZEROLOCALS and */
/* LASTONELOCAL are defined in nodes.h */
/* */
/* No local variables: */
	T_NONE,
	T_SEQUENCE,
	P_SYMBOL,
	P_COMP,
	P_IMPORT,
	P_EXPORT,
	P_NILLIT,
	P_PRAGMA,
	P_PROCESSDEF,
	P_INITDEF,
	P_RECOVERYDEF,
	P_UNAVAILABLEHANDLER,
	P_FAILUREHANDLER,
	P_IFSTAT,
	P_IFCLAUSE,
	P_ELSECLAUSE,
	P_LOOPSTAT,
	P_EXITSTAT,
	P_ASSIGNSTAT,
	P_ASSERTSTAT,
	P_FIXSTAT,
	P_REFIXSTAT,
	P_UNFIXSTAT,
	P_MOVESTAT,
	P_RETURNSTAT,
	P_RETURNANDFAILSTAT,
	P_EXP,
	P_FIELDSEL,
	P_SUBSCRIPT,
	P_SELECTION,
	P_WHEREWIDGIT,
	P_PRIMSTAT,
	P_WAITSTAT,
	P_UNARYEXP,
	P_RESTRICT,
	P_SETQ,
/* One local variable */
	T_IDENT,
	T_STRING,
	P_BOOLLIT,
	P_CHARLIT,
	P_INTLIT,
	P_REALLIT,
	P_STRINGLIT,
	P_BUILTINLIT,
	P_MONITOR,
	P_PARAM,
	P_ARG,
	P_FIELDREF,
	P_BLOCK,
	P_SIGNALSTAT,
	P_CHECKPOINTSTAT,
	P_CONSTDECL,
	P_VARDECL,
	P_VIEW,
	P_NTHRESULT,
	P_OPSIG,
/* Two local variables */
	P_GLOBALREF,
	P_SELFLIT,
	P_SYMREF,
	P_SYMDEF,
	P_OPNAME,
	P_OPDEF,
	P_INVOC,
/*Three local variables */
	P_RECORDLIT,
	P_UNIONLIT,
	P_ENUMLIT,
	P_VECTORLIT,
	P_KNOWCT,
	P_KNOWLOCAL,
	P_KNOWMANIFEST,
	P_ATLIT,
	P_OBLIT
} Tag;
#endif
